# Register

Static class to handle a slot-listening system.

Unlike the slots/signals Qt model, this class manages something that is more like a simple hashtable, where each slot has only one value. For that reason "Registers" makes more sense, the reference being to CPU registers.

This could be used for anything, but it's been built for a pretty specific phing need, and that is to allow access to dynamic values that are set by logic that is not represented in a build file. For exampe, we need a system for getting the current resource (file) that is being processed by a filterchain in a fileset.

Each slot corresponds to only one read-only, dynamic-value RegisterSlot object. In a build.xml register slots are expressed using a syntax similar to variables:

<replaceregexp> </replaceregexp>

The task/type must provide a supporting setter for the attribute:

`function setListeningReplace(RegisterSlot $slot) { $this->replace = $slot; }`

// in main() if ($this->replace instanceof RegisterSlot) { $this->regexp->setReplace($this->replace->getValue()); } else { $this->regexp->setReplace($this->replace); }

author | Hans Lellelid hans@xmpl.org
version | $Id: 0685f6aeb304d78c4ccb4eb966bdfec14745d4a7 $
package | phing.system.util

### Methods

## Returns RegisterSlot for specified key.

    getSlot(string $key) : \RegisterSlot

static

If not slot exists a new one is created for key.

### Arguments

#### $key

`string`

### Response

`\RegisterSlot`

### Properties

## Slots that have been registered

    slots :

static

### Type(s)

``